*************************************************************************
************************* TECNICAS DIGITALES III ************************
*************************************************************************
*                             BALANZA USB                               *
*                               (C) 2001                                *
*                                                                       *
*  Profesor: Ing Furfaro                                                *
*  Grupo:                                                               *
*           Martin Mirko                                                *
*           Claudio Santarsieri                                         *
*           Gaston Vainer                                               *
*                                                                       *
*                                                                       *
*  Para compilar ejecutar usb.bat , llama al compilador                 *
*  y compila los 3 archivos juntos (usb.asm , hc11e2.def,usb.def)       *
*  en usb.s19                                                           *      
*                                                                       *
*  la linea es:                                                         *
*                   c:>as11new usb.def hc11e2.def usb.asm               *
*************************************************************************

* CONSTANTES

ms1               EQU   333                     Constante para 1ms de delay
ms10              EQU   3333                    Constante para 10ms de delay
PLATILLO          EQU   1
INDICE            EQU   2

* VARIABLES
                  ORG   RAM

Sensor            RMB   1
Medicion          RMB   1
Salida            RMB   1
Estado            RMB   1
Estatico          RMB   1
Punt_taras        RMB   1
P_sal             RMB   1
Global            RMB   1
Aux               RMB   1
stalld            RMB   1
status            RMB   1
dtapid            RMB   1
desc_typ          RMB   1
desc_sze          RMB   1
desc_idx          RMB   1
pckt_dta          RMB   1
usb_cfg           RMB   1
setaddr           RMB   1
txstat            RMB   1
usb_buf           RMB   8
BufferRx          RMB   16
Buffer_Salidas    RMB   5
Buffer_Taras      RMB   10

* Aqui se copiara la rutina de grabacion de EEPROM

RutinaEnRam          EQU   *

**********************
* Programa Principal *
**********************

                  ORG   EEPROM

Principal         lds   #FIN_RAM                puntero de stack

                  jsr   InitHC11                Inicializacion del micro 

                  clra                          seteo variables a 0
                  staa  Salida
                  staa  status                 
                  staa  setaddr                
                  staa  dtapid 
                  staa  stalld 
                  staa  Global
                  staa  Estatico
                  staa  Estado
                  staa  Punt_taras
                  staa  P_sal

                  jsr   InitUsb                 inicializo 9603
                  cli                           habilito interrupciones

                  jsr   HabilSensor             habilito sensores

* Inicializo buffer de salidas

                  clra
                  ldx   #Buffer_Salidas
Borro_Sal         staa  0,X
                  inx
                  cpx   #Buffer_Salidas+5
                  bne   Borro_Sal

Loop              tst   Global                  compruebo si hubo sensor (global !=0)
                  beq   Loop

                  jsr   Pesar                   voy a pesar
                  clr   Global                  global = 0

                  tst   Estatico                compruebo si la maquina esta parada
                  bne   EsEstatico

* La maquina esta en funcionamiento

                  jsr   Trabajo                 salto a trabajo

EsEstatico        clr   Estatico                flag estatico=0

                  tst   usb_cfg                 Si esta configurado transmito , sino no
                  beq   Loop

                  sei                           deshabilito interrupciones temporiamente
                  jsr   Transmite               para transmitir
                  cli                           y vuelvo a habilitar

                  bra   Loop                    vuelvo al loop principal      

*********************
* Rutina de Trabajo *
*********************

Trabajo           ldaa  Estado                  
                  cmpa  #0
                  bne   NoEstado0

* Estado = 0 ->  Arranque . Espero sensor indice de primer platillo

                  ldaa  Sensor                  si el sensor no es indice no hago nada
                  bita  #INDICE
                  beq   FinTrabajo

                  inc   Estado                  sino , paso al estado 1 (tomar taras)
                  bra   FinTrabajo

NoEstado0         ldaa  Estado
                  cmpa  #1
                  bne   NoEstado1

* Estado = 1 -> Tomar taras (inicializar buffer)

                  ldx   #Buffer_Taras           Guardo tara de cada platillo (10 max)
                  ldab  Punt_taras              
                  abx
                  ldaa  Medicion
                  staa  0,X                     

                  ldaa  Sensor                  si el sensor era indice
                  bita  #INDICE                 termine y paso al estado 2
                  beq   FinTrabajo              sino , salgo 

                  inc   Estado
                  bra   FinTrabajo

* Trabajo Normal , Estado = 2

NoEstado1         ldx   #Buffer_Taras           apunto a la tara de cada platillo (10 max)
                  ldab  Punt_taras
                  abx
                  ldaa  Medicion                Le resto la tara , obtengo peso real en cuentas
                  suba  0,X                       
                  staa  Medicion

                  clrb
                  ldaa  Medicion
                  cmpa  #5
                  bls   Encontrado              supongo de +- 5 cuentas como vacio

                  cmpa  #250
                  bhs   Encontrado              supongo de +- 5 cuentas como vacio

                  ldx   #TablaSal               busco la salida a abrir segun tabla
                  incb

BuscoSalida       cmpa  0,X                     si la medicion es mayor sigo buscando
                  bls   Encontrado              hasta encontrar uno al que sea menor
                  inx
                  lslb                          en B llevo el bit correspondiente a cada salida      
                  cpx   #TablaSal+8
                  bne   BuscoSalida

Encontrado        stab  Salida                  guardo salida encontrada            

                  ldx   #Buffer_Salidas         Miro en el buffer de salidas
                  ldab  P_sal                   (FIFO) para abrir la siguiente
                  abx                           , el buffer es de 5 elementos

                  ldaa  0,X                     leo salida a abrir
                  ldy   #REGBASE
                  staa  PORTB,Y                 la abro

                  ldaa  Salida                  guardo la salida de la medicion
                  staa  0,X                     actual en el buffer                  

                  inc   P_sal                   incremento puntero

                  ldaa  #5                      reviso fin del buffer circular
                  cmpa  P_sal
                  bne   FinTrabajo

                  clr   P_sal       

FinTrabajo        rts

****************************************************
* Rutina de habilitacion de interrupcion de sensor *
****************************************************

HabilSensor       ldx   #REGBASE
                  ldd   TCNT,X                  Demora de 520 ms antes de habilitar sensores
                  addd  #$FFFF                  para evitar espurios
                  std   TOC1,X

                  bclr  TFLG1,X $7F             borro flag

DlyArranque       brclr TFLG1,X $80 DlyArranque     

                  ldaa  #%10000001              borro flag de interrupcion
                  staa  TFLG1,X

                  ldaa  #%00000001              activo int sensor
                  staa  TMSK1,X

                  rts

**************************
* Inicializacion de HC11 *
**************************

InitHC11          ldx   #REGBASE

                  ldaa  #%10010000              A/D encendido , IRQ por nivel
                  staa  OPTION,X

                  ldaa  #%00010111              habilito programacion de EEPROM
                  staa  BPROT,X

                  ldaa  #%00000011              Prescaler = 16
                  staa  TMSK2,X

                  ldaa  #$3B                    Seteo ports del SPI
                  staa  DDRD,X

                  ldaa  #$FF                    PORTD = $FF
                  staa  PORTD,X           

                  bset  PORTD,X BIT5            CS 9603 off

                  ldaa  #%00000010              Int Sensor activo por flanco descendente
                  staa  TCTL2,X

                  ldaa  #%01010000              SPI encendido , modo master 1 MHz
                  staa  SPCR,X

                  ldaa  SPSR,X                  Flush del SPI
                  ldaa  SPDR,X                  Flush del SPI

                  rts      

*******************************
* Inicializacion del USBN9603 *
*******************************

InitUsb           clr   usb_cfg                 variable de configuracion = 0
                  jsr   ClrMultiPKT             salgo del modo multi packet

                  ldaa  #MCNTRL
                  ldab  #SRST                   Reset por soft del 9603
                  jsr   EscribeUSB

                  ldaa  #MCNTRL
                  ldab  #VGE+INT_L_P            Enciendo 3.3V , INT activa baja push pull
                  jsr   EscribeUSB

                  ldaa  #CCONF
                  ldab  #CODIS                  desactivo CLKOUT
                  jsr   EscribeUSB

                  ldaa  #FAR
                  ldab  #AD_EN+0                Seteo direccion del disp = 0
                  jsr   EscribeUSB

                  ldaa  #EPC0                   EPC0 = 0 (endpoint 0)
                  clrb
                  jsr   EscribeUSB

                  ldaa  #NAKMSK
                  ldab  #NAK_O0                 eventos NAK 
                  jsr   EscribeUSB                  

                  ldaa  #TXMSK
                  ldab  #TXFIFO0+TXFIFO1        eventos TX 
                  jsr   EscribeUSB

                  ldaa  #RXMSK
                  ldab  #RXFIFO0+RXFIFO1        eventos RX
                  jsr   EscribeUSB

                  ldaa  #ALTMSK
                  ldab  #SD3+RESET_A            eventos alt
                  jsr   EscribeUSB

                  ldaa  #MAMSK                  eventos generales
                  ldab  #INTR_E+RX_EV+NAK+TX_EV+ALT   
                  jsr   EscribeUSB

                  jsr   FlushTX0                flush del TX0
                  jsr   EnableRX0               flush del RX0      

                  ldaa  #NFSR                   paso el nodo a operacional
                  ldab  #OPR_ST
                  jsr   EscribeUSB

                  ldaa  #MCNTRL                 
                  ldab  #VGE+INT_L_P+NAT        dispositivo attached
                  jsr   EscribeUSB

                  rts

******************************************************
* Rutina de escritura en USBN9603                    * 
*                                                    *
* Recibe en A la direccion y en B el dato a escribir *
******************************************************

EscribeUSB        pshx
                  ldx   #REGBASE                
                  bset  PORTD,X BIT5
                  bclr  PORTD,X BIT5            enciendo CS del 9603

                  anda  #$3F
                  oraa  #USBWRITE               agrego bit para escribir a la direccion
                  bsr   EnviaDatoUSB            envia la direccion
                  tba                           transfiero el dato a A
                  bsr   EnviaDatoUSB            envio el dato

                  bset  PORTD,X BIT5            desactivo CS del 9603
                  pulx
                  rts

****************************************************************
* Rutina de lectura en USBN9603                               * 
*                                                               *
* Recibe en A la direccion a leer y devuelve en A el dato leido *
*****************************************************************

LeeUSB            pshx
                  ldx   #REGBASE
                  bset  PORTD,X BIT5
                  bclr  PORTD,X BIT5            enciendo CS del 9603

                  anda  #$3F
                  oraa  #USBREAD                agrego bit para escribir a la direccion
                  bsr   EnviaDatoUSB            envia la direccion
                  clra
                  bsr   EnviaDatoUSB            envio un dato dummy

                  bset  PORTD,X BIT5            desactivo el cs

                  ldaa  SPDR,X                  leo el dato recibido
                  pulx
                  rts


********************************************
* RUTINA para enviar datos al 9603 por SPI *
* Recibe en A el dato a enviar             *
********************************************

EnviaDatoUSB      psha
                  ldaa  SPSR,X                  Flush del SPI
                  ldaa  SPDR,X                  Flush del SPI
                  pula
                  staa  SPDR,X                  guardo en SPI      
EsperaFlag        brclr SPSR,X BIT7 EsperaFlag  espero en flag
                  rts
                                    
***********************************************************************
* Rutina para setea un bit en un registro del 9603                    *
* Recibe en A la direccion y en B la mascara de bits correspondientes *
***********************************************************************

SeteaBitUSB       psha                          salvo A
                  stab  Aux                     salvo B (mascara) en Aux
                  bsr   LeeUSB
                  oraa  Aux
                  tab                           paso el dato a B
                  pula                          recupero A (direccion)
                  bsr   EscribeUSB
                  rts

***********************************************************************
* Rutina para borrar un bit en un registro del 9603                   *
* Recibe en A la direccion y en B la mascara de bits correspondientes *
***********************************************************************

BorraBitUSB       psha                          salvo A
                  comb                          complemento Mascara
                  stab  Aux                     salvo B (mascara) en Aux
                  bsr   LeeUSB
                  anda  Aux
                  tab                           paso el dato a B
                  pula                          recupero A (direccion)
                  bsr   EscribeUSB
                  rts

***************************
* Rutina de CLEAR_FEATURE *                                              
***************************

ClearFeature      ldx   #usb_buf                

                  ldaa  0,X                     leo byte 0 del buffer RX0
                  anda  #3                      (funcion a realizar)

                  cmpa  #2                      si es 2 , es ENDPOINT
                  bne   FinClrFeat

* ENDPOINT
                  ldaa  4,X                     leo byte 4 (numero de endpoint)
                  anda  #$0F                    
                  bne   No_End0                 A=0?

                  bclr  stalld BIT0             borro bit en variable stalld
                  ldaa  #EPC0                   enviar clrfeature al endp 0
                  bra   EnvClrFeat

No_End0           cmpa  #1
                  bne   No_End1

                  bclr  stalld BIT1             endpoint 1
                  ldaa  #EPC1
                  bra   EnvClrFeat

No_End1           cmpa  #2
                  bne   FinClrFeat

                  bclr  stalld BIT2             endpoint 2
                  ldaa  #EPC2

EnvClrFeat        ldab  #STALL                  envio el stall al endpoint correspondiente
                  jsr   BorraBitUSB

FinClrFeat        rts


*************************
* Rutina GET_DESCRIPTOR *
*************************

GetDescriptor     bset  status GETDESC          activo multipacket 
                  bset  status MLTIPKT
                                                      
                  ldx   #usb_buf                leo buffer RX0

                  ldaa  3,X                     byte 3(tipo de descriptor)
                  staa  desc_typ

                  cmpa  #DEVICE                 DEVICE descriptor
                  bne   No_DescDev2

                  clr   desc_idx                borro index
                  ldaa  #DEV_LENGTH             cargo tamano
                  staa  desc_sze
                  bra   EnvDescript             salto a enviarlo

No_DescDev2       cmpa  #CONFIGURATION          CONFIGURATION descriptor
                  bne   No_DescConf2

                  clr   desc_idx                borro index
                  ldaa  #CFG_DESC_SIZE          cargo tamano
                  staa  desc_sze
                  bra   EnvDescript

No_DescConf2      cmpa  #XSTRING                STRING descriptor
                  bne   No_DescString2

                  ldab  usb_buf+2               cargo index
                  stab  desc_idx
                  ldx   #STRING_DESC
                  abx
                  ldaa  0,X
                  staa  desc_sze                cargo tamano
                  bra   EnvDescript

No_DescString2    clr   desc_idx                no existe descirptor
                  clr   desc_sze                tamano e index = 0

* Envio el descriptor pedido

EnvDescript       ldx   #usb_buf                

                  tst   7,X                     compruebo tamano requerido
                  bne   EnvioDatos
                  ldaa  6,X                                       
                  cmpa  desc_sze

                  bhs   EnvioDatos

                  staa  desc_sze
                                                
EnvioDatos        ldy   #8                      envio de a 8 bytes
SigoEnvDat        bsr   mlti_pkt                salto a enviarlos
                  dey
                  bne   SigoEnvDat

                  rts

************************************
* Rutina para enviar el descriptor *
************************************

mlti_pkt          ldaa  desc_sze                si tamano = 0 salgo
                  cmpa  #0
                  bhi   DescORep

                  rts

DescORep          ldaa  status                  
                  bita  #GETDESC
                  beq   DescNoSop

* Cargo descriptor en endpoint 0

                  ldaa  desc_typ                leo tipo de descriptor
                  cmpa  #DEVICE
                  bne   No_DescDev

                  ldx   #DEV_DESC               DEVICE
                  ldab  desc_idx
                  abx
                  ldaa  0,X                     leo byte a enviar
                  staa  pckt_dta
                                    
                  bra   Finmlti_pkt

No_DescDev        cmpa  #CONFIGURATION
                  bne   No_DescConf

                  ldx   #CFG_DESC               CONFIGURATION
                  ldab  desc_idx
                  abx
                  ldaa  0,X                     leo byte a enviar
                  staa  pckt_dta
                                    
                  bra   Finmlti_pkt

No_DescConf       cmpa  #XSTRING                STRING
                  bne   No_DescString

                  ldx   #STRING_DESC
                  ldab  desc_idx
                  abx
                  ldaa  0,X
                  staa  pckt_dta                leo byte a enviar
                                    
                  bra   Finmlti_pkt

No_DescString     clr   pckt_dta                no existe ese descriptor
                                    
                  bra   Finmlti_pkt

* Descriptor no soportado

DescNoSop         clr   pckt_dta
                  
Finmlti_pkt       ldaa  #TXD0                   envio byte
                  ldab  pckt_dta
                  jsr   EscribeUSB
                  dec   desc_sze                    
                  inc   desc_idx                    

                  rts

*********************
* Rutina GET_STATUS *
*********************

GetStatus         ldx   #usb_buf
                  ldaa  0,X
                  anda  #$03
                  bne   No_StatDev              0 = DEVICE

                  bra   MismaDevInter

No_StatDev        cmpa  #1                      1 = INTERFACE
                  bne   No_StatInterf

* Si es DEVICE o INTERFACE hace esta *

MismaDevInter     ldaa  #TXD0
                  clrb                          para interface o device
                  jsr   EscribeUSB              transmito un 0
                  bra   FinGetStatus

No_StatInterf     cmpa  #2                      2 = ENDPOINT                
                  bne   No_StatEndp

                  ldaa  4,X                     leo numero de endpoint
                  anda  #$0F
                  cmpa  #2
                  bhi   FinGetStatus

                  bsr   EPSTATUS
                  bra   FinGetStatus

No_StatEndp       ldaa  #TXD0                   
                  clrb
                  jsr   EscribeUSB

FinGetStatus      ldaa  #TXD0
                  clrb
                  jsr   EscribeUSB
                  rts

EPSTATUS          inca
                  ldab  #BIT0

SigoRol           deca
                  beq   FinRol
                  lslb
                  bra   SigoRol

FinRol            stab  Aux                  guardo el bit a Activar
                  ldaa  stalld
                  bita  Aux
                  bne   SeteaBit

                  clrb
                  bra   EnviaBit

SeteaBit          ldab  #1

EnviaBit          ldaa  #TXD0
                  jsr   EscribeUSB

                  rts

****************************
* Rutina SET_CONFIGURATION *
****************************

SetConfig         ldx   #usb_buf
                  ldaa  2,X
                  staa  usb_cfg                 leo configuracion a activar y guardo

                  tsta                          si es 0 , desconfiguro USB
                  beq   DescConf
                  
                  clr   dtapid                  borro variables de estado
                  clr   stalld

                  ldaa  #TXC1                   flush endp 1
                  ldab  #FLUSH
                  jsr   EscribeUSB
                  
                  ldaa  #EPC1
                  ldab  #EP_EN+1                habilito endp 1
                  jsr   EscribeUSB

                  ldaa  #RXC1
                  ldab  #FLUSH
                  jsr   EscribeUSB
                  
                  ldaa  #EPC2                   habilito endp 2
                  ldab  #EP_EN+2
                  jsr   EscribeUSB

                  ldaa  #RXC1
                  ldab  #RX_EN
                  jsr   EscribeUSB

                  rts

* desconfigura el dispositivo

DescConf          ldaa  #EPC1                   disable del EP1   
                  clrb
                  jsr   EscribeUSB
                  ldaa  #EPC2                   disable del EP2
                  clrb
                  jsr   EscribeUSB

                  rts

**********************
* Rutina SET_FEATURE *
**********************

SetFeature        ldx   #usb_buf
                  ldaa  0,X
                  anda  #$03

                  cmpa  #2
                  bne   FinSetFeat

* ENDPOINT
                  ldaa  4,X                     leo numero de endpoint
                  anda  #$0F

                  cmpa  #0
                  bne   No_End02

                  bset  stalld BIT0             endp 0 
                  bra   FinSetFeat

No_End02          cmpa  #1
                  bne   No_End12

                  bset  stalld BIT1             endp 1
                  ldaa  #EPC1                   activo stall
                  ldab  #STALL
                  jsr   SeteaBitUSB
                  bra   FinSetFeat

No_End12          cmpa  #2
                  bne   FinSetFeat

                  bset  stalld BIT2             endp 2
                  ldaa  #EPC2                   activo stall
                  ldab  #STALL
                  jsr   SeteaBitUSB

FinSetFeat        rts


********************
* Stall endpoint 0 *
********************

StallEndp0        ldaa  #EPC0
                  ldab  #STALL                   
                  jsr   SeteaBitUSB
                  rts

**************************************
* Rutina de recepcion del endpoint 0 *
**************************************

Rx_0              ldaa  #RXS0
                  jsr   LeeUSB                  leo status end0

* es setup packet? 

                  bita  #SETUP_R
                  bne   Setup

                  jmp   No_Setup

* Es Setup Packet

Setup             ldx   #usb_buf

CargoUsbBuf       ldaa  #RXD0                   paso el FIFO de endp 0 a buffer de recepcion
                  jsr   LeeUSB
                  staa  0,X
                  inx
                  cpx   #usb_buf+8
                  bne   CargoUsbBuf

                  ldaa  #RXC0                   flush del endp0
                  ldab  #FLUSH
                  jsr   EscribeUSB

                  jsr   FlushTX0

                  ldaa  #EPC0                  desactivo stall en endp0
                  ldab  #STALL
                  jsr   BorraBitUSB

                  ldx   #usb_buf

                  ldaa  0,X                    Decodifico Tipo de Request
                  anda  #$60
                  bne   NoSoport               A=0?

* Standard Request
                  ldaa  1,X
                  cmpa  #CLEAR_FEATURE
                  bne   NoClrFeat

                  jsr   ClearFeature
                  bra   ContRequest

NoClrFeat         cmpa  #GET_CONFIG
                  bne   NoGetConf

                  ldaa  #TXD0
                  ldab  usb_cfg
                  jsr   EscribeUSB

                  bra   ContRequest

NoGetConf         cmpa  #GET_DESCRIPTOR
                  bne   NoGetDesc

                  jsr   GetDescriptor
                  bra   ContRequest

NoGetDesc         cmpa  #GET_INTERFACE
                  bne   NoGetInterf

                  ldaa  #TXD0                   devuelvo interface = 0
                  clrb
                  jsr   EscribeUSB

                  bra   ContRequest

NoGetInterf       cmpa  #GET_STATUS
                  bne   NoGetStat

                  jsr   GetStatus
                  bra   ContRequest

NoGetStat         cmpa  #SET_ADDRESS
                  bne   NoSetAddr

                  ldaa  2,X                     leo direccion asignada
                  oraa  #AD_EN
                  staa  setaddr                 y la guardo en variable

                  bra   ContRequest

NoSetAddr         cmpa  #SET_CONFIG
                  bne   NoSetConf

                  jsr   SetConfig
                  bra   ContRequest

NoSetConf         cmpa  #SET_FEATURE
                  bne   NoSetFeat

                  jsr   SetFeature 
                  bra   ContRequest

NoSetFeat         cmpa  #SET_INTERFACE
                  bne   NoSoport

                  tst   2,X                     
                  bne   FinSetInterf
                  jsr   StallEndp0              stall endp0

FinSetInterf      bra   ContRequest

NoSoport          jsr   StallEndp0

ContRequest       ldaa  #TXC0
                  ldab  #TX_TOGL+TX_EN
                  jsr   EscribeUSB

                  bclr  dtapid TGL0PID           
                  rts
*****
* No es Setup , es OUT

No_Setup          ldaa  status
                  bita  #MLTIPKT
                  beq   NO_MLTPKT

                  jsr   ClrMultiPKT
                  jsr   FlushTX0
                  
NO_MLTPKT         jsr   EnableRX0

                  rts


**************************************** 
* Rutina de transmision del endpoint 0 *
****************************************

Tx_0              ldaa  #TXS0
                  jsr   LeeUSB
                  staa  txstat                  leo status

                  bita  #TX_DONE                termino la transmision?
                  beq   TX_NoCompl              no ,salgo

* Fin de transmision

                  jsr   FlushTX0                flush de endp 0

                  ldaa  txstat                  hubo acknowledge?
                  bita  #ACK_STAT
                  beq   ACK_NoRec               no,salgo

                  ldaa  status                  bit del multipacket esta activo?
                  bita  #MLTIPKT
                  beq   NoMultiPckt

* Multi Packet activo , sigo enviando datos

                  ldy   #8                      envio 8 bytes mas
SigoTx0           jsr   mlti_pkt
                  dey
                  bne   SigoTx0

                  clrb                         elijo proximo PID(data0 -data1)

                  ldaa  dtapid
                  bita  #TGL0PID
                  beq   NoTX0PID

                  orab  #TX_TOGL

NoTX0PID          ldaa  #TXC0
                  orab  #TX_EN
                  jsr   EscribeUSB
                  
                  ldaa  dtapid
                  eora  #TGL0PID
                  staa  dtapid
                  bra   TX_NoCompl              voy al final

* No es multi packet

NoMultiPckt       tst   setaddr                 compruebo variable de direccion del 
                  beq   Adress0                 disp USB , si no es 0 voy a setearla

                  ldaa  #FAR                    setea direccion asignada en reg. FAR
                  ldab  setaddr
                  jsr   EscribeUSB
                  clr   setaddr                 borro variable direccion

Adress0           jsr   EnableRX0               rehabilito endp0
                  bra   TX_NoCompl

ACK_NoRec         jsr   ClrMultiPKT             salgo de multipacket
                  jsr   EnableRX0               rehabilito endp0

TX_NoCompl        rts

*************
* ClrMulTiPkt
*
* Sale del modo multi packet
****************

ClrMultiPKT       bclr  status GETDESC
                  bclr  status GETRPRT
                  bclr  status MLTIPKT
                  rts

************
* Reinicia el RX0 (endpoint0)
************

EnableRX0         ldaa  #RXC0
                  ldab  #RX_EN
                  jsr   EscribeUSB
                  rts

*********
* FLUSH DEL TX0
********

FlushTX0          ldaa  #TXC0
                  ldab  #FLUSH
                  jsr   EscribeUSB
                  rts

**********************************
* Rutina para NAK del endpoint 0 *
**********************************

Onak0             ldaa  status
                  bita  #MLTIPKT
                  beq   FinOnak0

                  jsr   ClrMultiPKT
                  jsr   FlushTX0
                  jsr   EnableRX0

FinOnak0          rts

*****************************
* Rutina de los eventos ALT *
*****************************

UsbAlt            ldaa  #ALTEV
                  jsr   LeeUSB
                  
                  bita  #RESET_A
                  beq   NoResetA

* Eventos de Reset

                  ldaa  #NFSR
                  ldab  #RST_ST
                  jsr   EscribeUSB              entra en estado reset
                  ldaa  #FAR
                  ldab  #AD_EN+0                  
                  jsr   EscribeUSB              adress default
                  ldaa  #EPC0
                  clrb
                  jsr   EscribeUSB              borro EPC0

                  jsr   FlushTX0                flush y disable TX0
                  jsr   EnableRX0               Reinicio RX0    

EventResume       ldaa  #ALTMSK
                  ldab  #SD3+RESET_A            seteo mascara normal          
                  jsr   EscribeUSB              adress default
                  ldaa  #NFSR
                  ldab  #OPR_ST
                  jsr   EscribeUSB              voy a operacion normal

                  bra   FinAltUsb

* Eventos de Resume

NoResetA          bita  #RESUME_A
                  beq   NoResumeA

                  bra   EventResume

NoResumeA         bita  #SD3
                  beq   FinAltUsb

* Evento suspend

                  ldaa  #ALTMSK
                  ldab  #RESUME_A+RESET_A       seteo mascara de modo suspend
                  jsr   EscribeUSB              adress default
                  ldaa  #NFSR
                  ldab  #SUS_ST
                  jsr   EscribeUSB              voy a modo suspend

FinAltUsb         rts


************************************************************
* Rutina de transmision de transmision FIFO 1 (endpoint 1) *
************************************************************

Tx_1              ldaa  #TXS1                   leo status del endp 1
                  jsr   LeeUSB

                  bita  #ACK_STAT               hubo ACKNOWLEDGE?
                  beq   FinTX1                  no, salgo
                  bita  #TX_DONE                termino la transmision?
                  beq   FinTX1                  no, salgo

                  ldaa  dtapid                  guardo proximo PID (data0 - data1)
                  eora  #TGL1PID
                  staa  dtapid

FinTX1            rts

************************************
* Rutina para transmitir los datos *
*                                  *
* Trasmito 4 bytes                 *
************************************

Transmite         ldaa  #TXD1                   cargo el estado del dispositivo
                  ldab  Estado                  0 = esperando sincronismo , 1=tomando taras , 2=pesando
                  jsr   EscribeUSB

                  ldaa  #TXD1                   cargo la medicion realizada
                  ldab  Medicion
                  jsr   EscribeUSB

                  ldaa  #TXD1                   cargo el sensor que ingreso
                  ldab  Sensor
                  jsr   EscribeUSB

                  ldaa  #TXD1                   cargo la salida abierta
                  ldab  Salida
                  jsr   EscribeUSB

* Busco el PID y enciendo Endpoint (elijo data0 o data1)

                  clrb
                  ldaa  dtapid
                  bita  #TGL1PID
                  beq   NoTX1PID

                  orab  #TX_TOGL
                  
NoTX1PID          ldaa  #TXC1
                  orab  #TX_LAST+TX_EN
                  jsr   EscribeUSB

                  rts

***********************************************
* Rutina de recepcion del FIFO 1 (endpoint 2) *
***********************************************

Rx_1              ldaa  #RXS1                   leo registro de status de endp 2
                  jsr   LeeUSB

                  bita  #SETUP_R                es SETUP ? si , salgo
                  bne   FinRX1
                  bita  #RX_ERR                 hay error? si ,voy a leer buffer
                  beq   Rx1_OK

                  ldaa  #RXC1                   hubo error
                  ldab  #FLUSH                  flush del endp 2
                  jsr   EscribeUSB
                  bra   FinRX1

Rx1_OK            ldx   #BufferRx

CargoBufRx        ldaa  #RXD1                   leo el FIFO de endp 2            
                  jsr   LeeUSB                  y lo paso al buffer de recepcion
                  staa  0,X
                  inx
                  cpx   #BufferRx+16
                  bne   CargoBufRx

                  ldx   #BufferRx
                  ldaa  0,X                     leo byte 0 del buffer (comando)

                  cmpa  #1
                  bne   NoCmd1

* Comando 1 = Pesar

                  inc   Global                  activo los flags , cuando vuelva al 
                  inc   Estatico                principal va a pesar
                  bra   FinRX1

* Comando 2 = Actualizar tabla de salidas

NoCmd1            cmpa  #2                      
                  bne   NoCmd2

                  bsr   CopiaRutina             copio la rutina en RAM

                  inx                           apunto al primer dato
                  ldy   #TablaSal               paso los datos en buffer RX

LoopTabla         ldaa  0,X                     a la EEPROM (la rutina de
                  jsr   RutinaEnRam             grabacion se ejecuta en RAM)
                  inx
                  iny
                  cpx   #BufferRx+9
                  bne   LoopTabla
                  bra   FinRX1

* Comando 3 = Tomar taras otra vez

NoCmd2            cmpa  #3
                  bne   FinRX1

                  clr   Estado                  Vuelve a tomar taras(cuando vuelve)

FinRX1            ldaa  #RXC1                   rehabilito endp 2
                  ldab  #RX_EN
                  jsr   EscribeUSB
                  rts

*******************************************************************
* Rutina para grabar pasar de EEPROM a RAM la rutina de grabacion
* de la tabla de limites , ya que no puede hacerse desde EEPROM .
*******************************************************************

CopiaRutina       pshx
                  ldx   #ByteProg
                  ldy   #RutinaEnRam

Cpyloop           ldab  0,X
                  stab  0,Y
                  inx
                  iny
                  cpx   #Endprg+1
                  bne   Cpyloop
                  pulx
                  rts


***********************************                                    
* Rutina de Interrupcion del 9603 *
***********************************

UsbIsr            ldx   #REGBASE
                  ldaa  #MAEV
                  jsr   LeeUSB

                  bset  PORTA,X BIT6               Led USB ON

                  bita  #NAK
                  beq   No_NAK     
                  bra   EventNAK

No_NAK            bita  #RX_EV
                  beq   No_RX_EV   
                  bra   EventRX

No_RX_EV          bita  #TX_EV
                  beq   No_TX_EV   
                  bra   EventTX

No_TX_EV          bita  #ALT
                  beq   No_ALT

                  jsr   UsbAlt

No_ALT            bra   FinUsbIsr


** Eventos de recepcion

EventRX           ldaa  #RXEV
                  jsr   LeeUSB
                                                      
                  bita  #RXFIFO0
                  beq   No_RXFIFO0   

                  jsr   Rx_0                    endpoint 0
                  bra   FinUsbIsr

No_RXFIFO0        bita  #RXFIFO1
                  beq   No_RXFIFO1

                  jsr   Rx_1                    endpoint 2
No_RXFIFO1        bra   FinUsbIsr

** Fin Eventos de recepcion

** Eventos de transmision

EventTX           ldaa  #TXEV
                  jsr   LeeUSB
                                                      
                  bita  #TXFIFO0
                  beq   No_TXFIFO0   

                  jsr   Tx_0                    endpoint 0
                  bra   FinUsbIsr

No_TXFIFO0        bita  #TXFIFO1
                  beq   No_TXFIFO1

                  jsr   Tx_1                    FIFOTX 1 endpoint 1

No_TXFIFO1        bra   FinUsbIsr


** Fin Eventos de transmision

** Eventos NAK

EventNAK          ldaa  #NAKEV
                  jsr   LeeUSB
                                                      
                  bita  #NAK_O0
                  beq   FinUsbIsr

                  jsr   Onak0                   endpoint 0

** Fin Eventos NAK

FinUsbIsr         bclr  PORTA,X BIT6            Led USB OFF
                  rti


***************************
* Interrupcion del sensor *
***************************

SensorIsr         ldx   #REGBASE

                  ldaa  #PLATILLO               guardo el tipo de sensor = platillo
                  staa  Sensor
                  ldaa  #$80                    cambio valor de Global
                  staa  Global

                  inc   Punt_taras              incremento puntero

                  brclr PORTA,X BIT1 NoIndice   el indice esta presente?

                  ldaa  Sensor                  lo agrego a Sensor
                  oraa  #INDICE
                  staa  Sensor
                  clr   Punt_taras              si esta el indice ,borro el puntero a taras

NoIndice          ldaa  #%00000001              borro flag de int
                  staa  TFLG1,X

                  rti
                  

****************************************
* Rutina Pesar                         *   
*                                      *
* Realiza el promedio de 60 mediciones *
****************************************

Pesar             ldx   #REGBASE
                  ldy   #0
                  ldaa  #15

SigoMidiendo      ldab  #4                      Empiezo medicion
                  stab  ADCTL,X
LoopAD            brclr ADCTL,X BIT7 LoopAD     64 micro seg / 4 conversiones

                  ldab  ADR1,X
                  aby
                  ldab  ADR2,X
                  aby
                  ldab  ADR3,X
                  aby
                  ldab  ADR4,X
                  aby                           acumulo en Y

                  pshx                          delay 1 ms
                  ldx   #ms1
Delay_1ms         dex
                  bne   Delay_1ms
                  pulx

                  deca
                  tsta
                  bne   SigoMidiendo

                  xgdy                          divido por 60 
                  ldx   #60
                  idiv
                  xgdx
                  stab  Medicion

                  rts


*******************
* DATOS EN EEPROM *
*******************

****************
* DESCRIPTORES *
****************


DEV_DESC          db     DEV_LENGTH             largo del descriptor
                  db     DEVICE                 tipo DEVICE      
                  dw     $0001                  revision de la norma USB
                  db     0                      device class              
                  db     0                      device subclass           
                  db     0                      device protocol           
                  db     8                      max packet size           
                  dw     $700C                  vendor ID      
                  dw     $0000                  product ID     
                  dw     $0001                  revision ID    
                  db     0                      index of manuf. string    
                  db     4                      index of prod.  string    
                  db     0                      index of ser. # string    
                  db     1                      numero de configuraciones


CFG_DESC          db     CFG_LENGTH             largo del descrip
                  db     CONFIGURATION          CONFIGURATION descriptor  
                  dw     $2000                  largo total de los bytes returnados(32)     
                  db     1                      numero de interfaces      
                  db     1                      numero de esta configuracion
                  db     0                      index del string
                  db     $40                    attr.: self powered       
                  db     0                      max consumo (0 mA)        

InterfDesc        db     INT_LENGTH            largo del descrip
                  db     INTERFACE             INTERFACE descriptor      
                  db     0                     numero de interface 
                  db     0                     seteo alternativo
                  db     2                     # de endpoints
                  db     $FF                   interface class           
                  db     1                     interface subclass        
                  db     $FF                   interface protocol        
                  db     0                     index del intf. string     

EndPointDesc1     db     END_LENGTH            largo del descrip
                  db     ENDPOINT              ENDPOINT descriptor       
                  db     $81                   direccion (IN) Endpoint 1   
                  db     3                     atributos  (INTERRUPT)   
                  dw     $0800                 max packet size (8)      
                  db     $64                   intervalo (100 ms)             

EndPointDesc2     db     END_LENGTH            largo del descrip
                  db     ENDPOINT              ENDPOINT descriptor       
                  db     $02                   direccion (OUT) Endpoint 2
                  db     3                     atributos  (INTERRUPT)   
                  dw     $1000                 max packet size (16)      
                  db     $64                   intervalo (100 ms)             

CFG_DESC_SIZE     EQU    * - CFG_DESC          tamano del conf descriptor

* Descriptor string del producto

STRING_DESC       db     4                     array LANGID 
                  db     3                     (Ingles)
                  db     9
                  db     4

StringProd        db     24                    Tamao (24 bytes) 
                  db     3                     Tipo string 
                  db     'B'
                  db     0
                  db     'a'
                  db     0
                  db     'l'
                  db     0
                  db     'a'
                  db     0
                  db     'n'
                  db     0
                  db     'z'
                  db     0
                  db     'a'
                  db     0
                  db     ' '
                  db     0
                  db     'U'
                  db     0
                  db     'S'
                  db     0
                  db     'B'
                  db     0



**************************************************************************************
* Rutina de programacion EEPROM , recibe en A el byte a grabar y en Y la direccion
* !Ojo , se copia en RAM y se ejecuta desde ahi!
* Esta rutina es un dato mas *
**********************************

ByteProg          pshx
                  ldx   #REGBASE
                  ldab  #$16
                  stab  PPROG,X
                  stab  0,Y
                  ldab  #$17
                  stab  PPROG,X
                  bsr   dly10
                  clr   PPROG,X


                  ldab  #$02
                  stab  PPROG,X
                  staa  0,Y
                  ldab  #$03
                  stab  PPROG,X
                  bsr   dly10
                  clr   PPROG,X
                  pulx
                  rts

*******************************
dly10             pshx
                  ldx   #ms10
loop10            dex
                  bne   loop10
                  pulx
Endprg            rts
*******************************


********************
* Tabla de limites *
********************

TablaSal           RMB   8                      son 8 bytes para los limites


****************************
* Vectores de Interrupcion *
****************************

                  ORG   $FFEA                   Vector del input capture 3 
                  dw    SensorIsr               para sensor platillo
                                                            
                  ORG   $FFF2                   Vector del pin IRQ para 
                  dw    UsbIsr                  controlador USB9603

                  ORG   $FFF8                   Vectores de Reset
                  dw    EEPROM                  Reset por codigo ilegal
                  dw    EEPROM                  Reset por COP
                  dw    EEPROM                  Reset por falla de clock
                  dw    EEPROM                  Reset normal
